/*
 * GDIPlus.h
 * @desc GDI+Ɋւ鏈̂t@C
 * @auther K
 * $ld$
 * Copyright(c) 2005 K, All rights reserved
 */

#ifndef __GDIPlus_H__
#define __GDIPlus_H__

#include <windows.h>
#include <gdiplus.h>
using namespace Gdiplus;

//---------------------------------------------------------------------------//
// GDI+ǗNX
//---------------------------------------------------------------------------//
class CGDIPlus
{
public:
	// \z
	CGDIPlus( void );
	// 
	~CGDIPlus( void );

	void Initialize( void );
	void Uninitialize( void );

	// 摜
	bool CreateImageFromFile( const char *pszFileName );
	bool CreateImage( const unsigned char *pszData, DWORD dwSize );
	// 摜ۑ
	bool SaveImage( const char *pszFileName, int nFramePosition, int nSelectedFormat );
	void SetDispParam( HDC hDC );
	void GetImageSize( int *pnWidth, int *pnHeight );
	// t[擾
	int GetFrameCount( void ){ return m_nFrameCount; }
	// ǂݍ݂ɑΉĂ摜tH[}bg擾
	void GetCanReadFormat( char *pszMessage );
	// o͂ɑΉĂ摜tH[}bg擾
	int GetCanWriteFormat( char pszFormat[0x100][0x100], char pszExt[0x100][0x100] );

	// Aj[V
	int DrawImage( void );
	// ̕`ʒu
	void NextPosition( void )
	{
		if( ++m_nFramePosition >= m_nFrameCount )
			m_nFramePosition = 0;
	}
	// O̕`ʒu
	void PrePosition( void )
	{
		if( --m_nFramePosition < 0 )
			m_nFramePosition = m_nFrameCount-1;

		if( m_nFramePosition < 0 )
			m_nFramePosition = 0;
	}
	// ŏ̕`ʒu
	void FirstPosition( void )
	{
		m_nFramePosition = 0;
	}
	// Ō̕`ʒu
	void LastPosition( void )
	{
		m_nFramePosition = m_nFrameCount-1;
		if( m_nFramePosition < 0 )
			m_nFramePosition = 0;
	}
	// t[|WVZbg
	void ResetFramePosition( void ){ m_nFramePosition = -1; }
	// ݂̃t[|WV擾
	int GetFramePosition( void ){ return m_nFramePosition; }
	// Image擾
	Bitmap *GetImage( void ){ return m_pImage; }

	long			m_lNextImageTime;	// ̃t[܂ł̑҂

protected:
	HGLOBAL			m_hGlobal;			// obt@p
	Bitmap			*m_pImage;			// \C[W
	PropertyItem	*m_pPropertyItem;	// ̃t[܂ł̑҂ԗp̃vpeB
	IStream			*m_pStream;

	int m_nFrameCount;					// t[
	int m_nFramePosition;				// ݂̃t[ʒu

	HDC m_hDC;							// `HDC
};


#endif
