/*
 * MainWindow.cpp
 * @desc CEBhEǗɊւ鏈̂t@C
 * @auther K
 * $ld$
 * Copyright(c) 2005 K, All rights reserved
 */

#include <windows.h>
#include "Main.h"
#include "Funcs.h"
#include "resource.h"

#define ID_TIMER 1

// R[obN֐̃vg^Cv錾
LRESULT WINAPI MainWindowProc( HWND, UINT, WPARAM, LPARAM );


/**
 *	\z
 *
 */
MainWindow::MainWindow()
{
	m_hWnd			= NULL;

	m_nTimerID		= NULL;

	m_pMyWindowProc	= NULL;
}

/**
 *	
 *
 */
MainWindow::~MainWindow( void )
{
}

/**
 *	EBhE
 *
 *	@param	hInstance		: CX^X
 *	@param	bFullScrn		: EBhE[h
 *	@result					: true/ false/s
 */
bool MainWindow::InitWindow( HINSTANCE hInstance )
{
	m_hWnd = NULL;

	/*-------------------------------*/
	//EBhENXo^
	/*-------------------------------*/
	WNDCLASSEX wc;
	wc.cbSize			= sizeof(WNDCLASSEX);					// TCY
	wc.style			= 0;									// X^C
	wc.lpfnWndProc		= MainWindowProc;						// vV[W
	wc.cbClsExtra		= 0;									// NXp[U`TCY
	wc.cbWndExtra		= 0;									// EBhEp[U`TCY
	wc.hInstance		= hInstance;							// CX^X
	wc.hIcon			= NULL;
	wc.hIcon			= ::LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));	// ACR
	wc.hCursor			= ::LoadCursor( NULL, IDC_ARROW );			// J[\
	wc.hbrBackground	= (HBRUSH)::GetStockObject( BLACK_BRUSH );	// wiF

	wc.lpszMenuName		= NULL;										// j[
	wc.lpszClassName	= WNDCLASS_NAME;							// NX
//	wc.hIconSm			= ::LoadIcon(NULL, IDI_APPLICATION);		// X[ACR
	wc.hIconSm			= NULL;

	if( !::RegisterClassEx( &wc ) )
		return false;

	/*-------------------------------*/
	//EBhE
	/*-------------------------------*/
	m_hWnd = ::CreateWindowEx(
		WS_EX_APPWINDOW|WS_EX_ACCEPTFILES,
		WNDCLASS_NAME,
		TITLE_NAME,
		WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, SCREEN_WIDTH, SCREEN_HEIGHT,
		(HWND)NULL, (HMENU)NULL,
		hInstance, (LPSTR)NULL );
	if( !m_hWnd )
	{
		return false;
	}

	::ShowWindow( m_hWnd, SW_SHOW );
	::SetFocus( m_hWnd );

	return true;
}

/**
 *	CEBhĚn
 *
 *	@result					: true/ false/s
 */
bool MainWindow::ClearWindow( void )
{
	// EChENX̓o^폜
	::UnregisterClass( WNDCLASS_NAME, g_main.m_hInstance );

	return true;
}

//*****************************************************************************
// bZ[W
//*****************************************************************************

/**
 *	Aj[V^C}[ݒ
 *
 *	@param	lNextImageTime	: ^C}[Ԋu
 */
void MainWindow::StartAnimTimer( long lNextImageTime )
{
	m_nTimerID = ::SetTimer( m_hWnd, ID_TIMER, lNextImageTime, NULL );
}

/**
 *	Aj[V^C}[~
 *
 *	@param	lNextImageTime	: ^C}[Ԋu
 */
void MainWindow::StopAnimTimer( void )
{
	::KillTimer( m_hWnd, m_nTimerID );
	m_nTimerID = 0;
}

/**
 *	Aj[V^C}[ĐAꎞ~
 *
 *	@param	lNextImageTime	: ^C}[Ԋu
 */
void MainWindow::StartOrStopAnimTimer( long lNextImageTime )
{
	if( !m_nTimerID )
		StartAnimTimer( lNextImageTime );
	else
		StopAnimTimer();
}

/**
 *	CEBhẼbZ[W
 *
 *	@param	hWnd			: EBhEnh
 *	@param	message			: bZ[WID
 *	@param	wParam			: wp[^
 *	@param	lParam			: lp[^
 *	@result					: vV[W̕Ԃl
 */
LRESULT WINAPI MainWindowProc
		( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam )
{
	switch( message )
	{
	case WM_CREATE:
		g_main.OnCreate( hWnd, wParam, lParam );
		break;

	case WM_COMMAND:
		switch( LOWORD(wParam) )
		{
		case ID_NEXT_FRAME:
			// ̃t[\
			g_main.DrawNextFrame();
			break;

		case ID_PRE_FRAME:
			// Õt[\
			g_main.DrawPreFrame();
			break;

		case ID_FIRST_FRAME:
			// ŏ̃t[\
			g_main.DrawFirstFrame();
			break;

		case ID_LAST_FRAME:
			// Ō̃t[\
			g_main.DrawLastFrame();
			break;

		case ID_START_STOP:
			// ĐAꎞ~
			g_main.StartOrStopAnim();
			break;

		case ID_WINDOW_SIZE:
			// EBhETCY摜ɍ킹
			g_main.ResetWindowSize();
			break;

		case ID_COPY:
			// ݂̉ʂNbv{[hɃRs[
			g_main.CopyImageToClipBoard();
			break;

		case ID_SAVE:
			// SẴt[ۑ
			g_main.SaveAllImage();
			break;

		default:
			return FALSE;
		}
		break;

	case WM_SIZE:
		g_main.OnSize( hWnd, LOWORD(lParam), HIWORD(lParam) );
		return 0;

	case WM_DISPLAYCHANGE:
		g_main.OnDisplayChange( hWnd, LOWORD(lParam), HIWORD(lParam) );
		break;

	case WM_PAINT:
		g_main.OnPaint( hWnd );
		break;

	// t@ChbvꂽƂ̏
	case WM_DROPFILES:
	{
		// hbvꂽt@C擾
		char pszFileName[MAX_PATH+1];
		::DragQueryFile( (HDROP)wParam, 0, pszFileName, MAX_PATH );

		// t@Cǂݍ
		g_main.DrawImageFile( pszFileName );

	}
		break;

	case WM_SYSKEYDOWN:
		if( wParam == VK_MENU )
			return 0;
		break;

	case WM_VSCROLL:
		g_main.OnVScroll( hWnd, LOWORD(wParam), HIWORD(wParam) );
		return 0;

	case WM_HSCROLL:
		g_main.OnHScroll( hWnd, LOWORD(wParam), HIWORD(wParam) );
		return 0;

	case WM_KEYDOWN:
		// 
		if( wParam == VK_RIGHT )
		{
			// ̃t[\
			g_main.DrawNextFrame();
		}
		// 
		else if( wParam == VK_LEFT )
		{
			// Õt[\
			g_main.DrawPreFrame();
		}
		// 
		else if( wParam == VK_UP )
		{
			// 擪̃t[\
			g_main.DrawFirstFrame();
		}
		// 
		else if( wParam == VK_DOWN )
		{
			// Ō̃t[\
			g_main.DrawLastFrame();
		}
		// Space
		else if( wParam == VK_SPACE )
		{
			// ĐEꎞ~
			g_main.StartOrStopAnim();
		}
		break; 

	case WM_LBUTTONDOWN:
		g_main.OnLButtonDown( LOWORD(lParam), HIWORD(lParam) );
		break;

	case WM_RBUTTONDOWN:
		g_main.OnRButtonDown( LOWORD(lParam), HIWORD(lParam) );
		break;

	case WM_MOUSEMOVE:
		g_main.OnMouseMove( hWnd, wParam, LOWORD(lParam), HIWORD(lParam) );
		break;

	case WM_SETCURSOR:
	{
		int nHitTest = LOWORD(lParam);
		if( nHitTest == HTCLIENT )
		{
			// ̂ŃJ[\`
//			HCURSOR hCursor = ::LoadCursor( g_main.m_hInstance, "MYCURSOR" );
			HCURSOR hCursor = ::LoadCursor( NULL, IDC_SIZEALL );
			::SetCursor( hCursor );
			return TRUE;
		}
	}
		break;

	case WM_TIMER:
		g_main.DrawImage( true );
		break;

	case WM_DESTROY:
		// hbO&hbvIt
		::DragAcceptFiles( hWnd, FALSE );

		// Aj[V^C}[~
		g_main.m_MainWindow.StopAnimTimer();

		::PostQuitMessage( 0 );
		break;
	}

	// [U`̃vV[WĂяo
	if( g_main.m_MainWindow.m_pMyWindowProc )
		g_main.m_MainWindow.m_pMyWindowProc( hWnd, message, wParam, lParam );

	return ::DefWindowProc( hWnd, message, wParam, lParam );
}
